diff -crBPN --exclude=wordpress.sql --exclude=wp-config.php --exclude=.htaccess-dist --exclude=advanced-cache.php --exclude=wp-cache-config.php --exclude=wordpress.sql --exclude=wp-config.php --exclude=.htaccess-dist --exclude=wp-cache-config.php --exclude=editor_plugin.js --exclude=jetpack --exclude=.files.list --exclude=wordpress-3.5.pl /home/packages/code/qi/SOURCES/wordpress-3.4.2/wp-includes/media.php /home/packages/code/qi/SOURCES/wordpress-3.5/wp-includes/media.php
*** /home/packages/code/qi/SOURCES/wordpress-3.4.2/wp-includes/media.php	2012-10-29 12:35:29.000000000 -0500
--- /home/packages/code/qi/SOURCES/wordpress-3.5/wp-includes/media.php	2012-12-17 16:18:39.000000000 -0600
***************
*** 3,8 ****
--- 3,9 ----
   * WordPress API for media display.
   *
   * @package WordPress
+  * @subpackage Media
   */
  
  /**
***************
*** 29,39 ****
   * @param int $width Width of the image
   * @param int $height Height of the image
   * @param string|array $size Size of what the result image should be.
   * @return array Width and height of what the result image should resize to.
   */
! function image_constrain_size_for_editor($width, $height, $size = 'medium') {
  	global $content_width, $_wp_additional_image_sizes;
  
  	if ( is_array($size) ) {
  		$max_width = $size[0];
  		$max_height = $size[1];
--- 30,44 ----
   * @param int $width Width of the image
   * @param int $height Height of the image
   * @param string|array $size Size of what the result image should be.
+  * @param context Could be 'display' (like in a theme) or 'edit' (like inserting into an editor)
   * @return array Width and height of what the result image should resize to.
   */
! function image_constrain_size_for_editor($width, $height, $size = 'medium', $context = null ) {
  	global $content_width, $_wp_additional_image_sizes;
  
+ 	if ( ! $context )
+ 		$context = is_admin() ? 'edit' : 'display';
+ 
  	if ( is_array($size) ) {
  		$max_width = $size[0];
  		$max_height = $size[1];
***************
*** 64,70 ****
  	} elseif ( isset( $_wp_additional_image_sizes ) && count( $_wp_additional_image_sizes ) && in_array( $size, array_keys( $_wp_additional_image_sizes ) ) ) {
  		$max_width = intval( $_wp_additional_image_sizes[$size]['width'] );
  		$max_height = intval( $_wp_additional_image_sizes[$size]['height'] );
! 		if ( intval($content_width) > 0 && is_admin() ) // Only in admin. Assume that theme authors know what they're doing.
  			$max_width = min( intval($content_width), $max_width );
  	}
  	// $size == 'full' has no constraint
--- 69,75 ----
  	} elseif ( isset( $_wp_additional_image_sizes ) && count( $_wp_additional_image_sizes ) && in_array( $size, array_keys( $_wp_additional_image_sizes ) ) ) {
  		$max_width = intval( $_wp_additional_image_sizes[$size]['width'] );
  		$max_height = intval( $_wp_additional_image_sizes[$size]['height'] );
! 		if ( intval($content_width) > 0 && 'edit' == $context ) // Only in admin. Assume that theme authors know what they're doing.
  			$max_width = min( intval($content_width), $max_width );
  	}
  	// $size == 'full' has no constraint
***************
*** 73,79 ****
  		$max_height = $height;
  	}
  
! 	list( $max_width, $max_height ) = apply_filters( 'editor_max_image_size', array( $max_width, $max_height ), $size );
  
  	return wp_constrain_dimensions( $width, $height, $max_width, $max_height );
  }
--- 78,84 ----
  		$max_height = $height;
  	}
  
! 	list( $max_width, $max_height ) = apply_filters( 'editor_max_image_size', array( $max_width, $max_height ), $size, $context );
  
  	return wp_constrain_dimensions( $width, $height, $max_width, $max_height );
  }
***************
*** 225,234 ****
  	list( $img_src, $width, $height ) = image_downsize($id, $size);
  	$hwstring = image_hwstring($width, $height);
  
  	$class = 'align' . esc_attr($align) .' size-' . esc_attr($size) . ' wp-image-' . $id;
  	$class = apply_filters('get_image_tag_class', $class, $id, $align, $size);
  
! 	$html = '<img src="' . esc_attr($img_src) . '" alt="' . esc_attr($alt) . '" title="' . esc_attr($title).'" '.$hwstring.'class="'.$class.'" />';
  
  	$html = apply_filters( 'get_image_tag', $html, $id, $alt, $title, $align, $size );
  
--- 230,241 ----
  	list( $img_src, $width, $height ) = image_downsize($id, $size);
  	$hwstring = image_hwstring($width, $height);
  
+ 	$title = $title ? 'title="' . esc_attr( $title ) . '" ' : '';
+ 
  	$class = 'align' . esc_attr($align) .' size-' . esc_attr($size) . ' wp-image-' . $id;
  	$class = apply_filters('get_image_tag_class', $class, $id, $align, $size);
  
! 	$html = '<img src="' . esc_attr($img_src) . '" alt="' . esc_attr($alt) . '" ' . $title . $hwstring . 'class="' . $class . '" />';
  
  	$html = apply_filters( 'get_image_tag', $html, $id, $alt, $title, $align, $size );
  
***************
*** 236,269 ****
  }
  
  /**
-  * Load an image from a string, if PHP supports it.
-  *
-  * @since 2.1.0
-  *
-  * @param string $file Filename of the image to load.
-  * @return resource The resulting image resource on success, Error string on failure.
-  */
- function wp_load_image( $file ) {
- 	if ( is_numeric( $file ) )
- 		$file = get_attached_file( $file );
- 
- 	if ( ! file_exists( $file ) )
- 		return sprintf(__('File &#8220;%s&#8221; doesn&#8217;t exist?'), $file);
- 
- 	if ( ! function_exists('imagecreatefromstring') )
- 		return __('The GD image library is not installed.');
- 
- 	// Set artificially high because GD uses uncompressed images in memory
- 	@ini_set( 'memory_limit', apply_filters( 'image_memory_limit', WP_MAX_MEMORY_LIMIT ) );
- 	$image = imagecreatefromstring( file_get_contents( $file ) );
- 
- 	if ( !is_resource( $image ) )
- 		return sprintf(__('File &#8220;%s&#8221; is not an image.'), $file);
- 
- 	return $image;
- }
- 
- /**
   * Calculates the new dimensions for a downsampled image.
   *
   * If either width or height are empty, no constraint is applied on
--- 243,248 ----
***************
*** 320,326 ****
  }
  
  /**
!  * Retrieve calculated resized dimensions for use in imagecopyresampled().
   *
   * Calculate dimensions and coordinates for a resized image that fits within a
   * specified width and height. If $crop is true, the largest matching central
--- 299,305 ----
  }
  
  /**
!  * Retrieve calculated resized dimensions for use in WP_Image_Editor.
   *
   * Calculate dimensions and coordinates for a resized image that fits within a
   * specified width and height. If $crop is true, the largest matching central
***************
*** 393,484 ****
  }
  
  /**
-  * Scale down an image to fit a particular size and save a new copy of the image.
-  *
-  * The PNG transparency will be preserved using the function, as well as the
-  * image type. If the file going in is PNG, then the resized image is going to
-  * be PNG. The only supported image types are PNG, GIF, and JPEG.
-  *
-  * Some functionality requires API to exist, so some PHP version may lose out
-  * support. This is not the fault of WordPress (where functionality is
-  * downgraded, not actual defects), but of your PHP version.
-  *
-  * @since 2.5.0
-  *
-  * @param string $file Image file path.
-  * @param int $max_w Maximum width to resize to.
-  * @param int $max_h Maximum height to resize to.
-  * @param bool $crop Optional. Whether to crop image or resize.
-  * @param string $suffix Optional. File suffix.
-  * @param string $dest_path Optional. New image file path.
-  * @param int $jpeg_quality Optional, default is 90. Image quality percentage.
-  * @return mixed WP_Error on failure. String with new destination path.
-  */
- function image_resize( $file, $max_w, $max_h, $crop = false, $suffix = null, $dest_path = null, $jpeg_quality = 90 ) {
- 
- 	$image = wp_load_image( $file );
- 	if ( !is_resource( $image ) )
- 		return new WP_Error( 'error_loading_image', $image, $file );
- 
- 	$size = @getimagesize( $file );
- 	if ( !$size )
- 		return new WP_Error('invalid_image', __('Could not read image size'), $file);
- 	list($orig_w, $orig_h, $orig_type) = $size;
- 
- 	$dims = image_resize_dimensions($orig_w, $orig_h, $max_w, $max_h, $crop);
- 	if ( !$dims )
- 		return new WP_Error( 'error_getting_dimensions', __('Could not calculate resized image dimensions') );
- 	list($dst_x, $dst_y, $src_x, $src_y, $dst_w, $dst_h, $src_w, $src_h) = $dims;
- 
- 	$newimage = wp_imagecreatetruecolor( $dst_w, $dst_h );
- 
- 	imagecopyresampled( $newimage, $image, $dst_x, $dst_y, $src_x, $src_y, $dst_w, $dst_h, $src_w, $src_h);
- 
- 	// convert from full colors to index colors, like original PNG.
- 	if ( IMAGETYPE_PNG == $orig_type && function_exists('imageistruecolor') && !imageistruecolor( $image ) )
- 		imagetruecolortopalette( $newimage, false, imagecolorstotal( $image ) );
- 
- 	// we don't need the original in memory anymore
- 	imagedestroy( $image );
- 
- 	// $suffix will be appended to the destination filename, just before the extension
- 	if ( !$suffix )
- 		$suffix = "{$dst_w}x{$dst_h}";
- 
- 	$info = pathinfo($file);
- 	$dir = $info['dirname'];
- 	$ext = $info['extension'];
- 	$name = wp_basename($file, ".$ext");
- 
- 	if ( !is_null($dest_path) and $_dest_path = realpath($dest_path) )
- 		$dir = $_dest_path;
- 	$destfilename = "{$dir}/{$name}-{$suffix}.{$ext}";
- 
- 	if ( IMAGETYPE_GIF == $orig_type ) {
- 		if ( !imagegif( $newimage, $destfilename ) )
- 			return new WP_Error('resize_path_invalid', __( 'Resize path invalid' ));
- 	} elseif ( IMAGETYPE_PNG == $orig_type ) {
- 		if ( !imagepng( $newimage, $destfilename ) )
- 			return new WP_Error('resize_path_invalid', __( 'Resize path invalid' ));
- 	} else {
- 		// all other formats are converted to jpg
- 		if ( 'jpg' != $ext && 'jpeg' != $ext )
- 			$destfilename = "{$dir}/{$name}-{$suffix}.jpg";
- 		if ( !imagejpeg( $newimage, $destfilename, apply_filters( 'jpeg_quality', $jpeg_quality, 'image_resize' ) ) )
- 			return new WP_Error('resize_path_invalid', __( 'Resize path invalid' ));
- 	}
- 
- 	imagedestroy( $newimage );
- 
- 	// Set correct file permissions
- 	$stat = stat( dirname( $destfilename ));
- 	$perms = $stat['mode'] & 0000666; //same permissions as parent folder, strip off the executable bits
- 	@ chmod( $destfilename, $perms );
- 
- 	return $destfilename;
- }
- 
- /**
   * Resize an image to make a thumbnail or intermediate size.
   *
   * The returned array has the file size, the image width, and image height. The
--- 372,377 ----
***************
*** 493,508 ****
   * @param bool $crop Optional, default is false. Whether to crop image to specified height and width or resize.
   * @return bool|array False, if no image was created. Metadata array on success.
   */
! function image_make_intermediate_size($file, $width, $height, $crop=false) {
  	if ( $width || $height ) {
! 		$resized_file = image_resize($file, $width, $height, $crop);
! 		if ( !is_wp_error($resized_file) && $resized_file && $info = getimagesize($resized_file) ) {
! 			$resized_file = apply_filters('image_make_intermediate_size', $resized_file);
! 			return array(
! 				'file' => wp_basename( $resized_file ),
! 				'width' => $info[0],
! 				'height' => $info[1],
! 			);
  		}
  	}
  	return false;
--- 386,403 ----
   * @param bool $crop Optional, default is false. Whether to crop image to specified height and width or resize.
   * @return bool|array False, if no image was created. Metadata array on success.
   */
! function image_make_intermediate_size( $file, $width, $height, $crop = false ) {
  	if ( $width || $height ) {
! 		$editor = wp_get_image_editor( $file );
! 
! 		if ( is_wp_error( $editor ) || is_wp_error( $editor->resize( $width, $height, $crop ) ) )
! 			return false;
! 
! 		$resized_file = $editor->save();
! 
! 		if ( ! is_wp_error( $resized_file ) && $resized_file ) {
! 			unset( $resized_file['path'] );
! 			return $resized_file;
  		}
  	}
  	return false;
***************
*** 655,666 ****
  		$hwstring = image_hwstring($width, $height);
  		if ( is_array($size) )
  			$size = join('x', $size);
! 		$attachment =& get_post($attachment_id);
  		$default_attr = array(
  			'src'	=> $src,
  			'class'	=> "attachment-$size",
  			'alt'	=> trim(strip_tags( get_post_meta($attachment_id, '_wp_attachment_image_alt', true) )), // Use Alt field first
- 			'title'	=> trim(strip_tags( $attachment->post_title )),
  		);
  		if ( empty($default_attr['alt']) )
  			$default_attr['alt'] = trim(strip_tags( $attachment->post_excerpt )); // If not, Use the Caption
--- 550,560 ----
  		$hwstring = image_hwstring($width, $height);
  		if ( is_array($size) )
  			$size = join('x', $size);
! 		$attachment = get_post($attachment_id);
  		$default_attr = array(
  			'src'	=> $src,
  			'class'	=> "attachment-$size",
  			'alt'	=> trim(strip_tags( get_post_meta($attachment_id, '_wp_attachment_image_alt', true) )), // Use Alt field first
  		);
  		if ( empty($default_attr['alt']) )
  			$default_attr['alt'] = trim(strip_tags( $attachment->post_excerpt )); // If not, Use the Caption
***************
*** 775,785 ****
   * @return string HTML content to display gallery.
   */
  function gallery_shortcode($attr) {
! 	global $post;
  
  	static $instance = 0;
  	$instance++;
  
  	// Allow plugins/themes to override the default gallery template.
  	$output = apply_filters('post_gallery', '', $attr);
  	if ( $output != '' )
--- 669,686 ----
   * @return string HTML content to display gallery.
   */
  function gallery_shortcode($attr) {
! 	$post = get_post();
  
  	static $instance = 0;
  	$instance++;
  
+ 	if ( ! empty( $attr['ids'] ) ) {
+ 		// 'ids' is explicitly ordered, unless you specify otherwise.
+ 		if ( empty( $attr['orderby'] ) )
+ 			$attr['orderby'] = 'post__in';
+ 		$attr['include'] = $attr['ids'];
+ 	}
+ 
  	// Allow plugins/themes to override the default gallery template.
  	$output = apply_filters('post_gallery', '', $attr);
  	if ( $output != '' )
***************
*** 810,816 ****
  		$orderby = 'none';
  
  	if ( !empty($include) ) {
- 		$include = preg_replace( '/[^0-9,]+/', '', $include );
  		$_attachments = get_posts( array('include' => $include, 'post_status' => 'inherit', 'post_type' => 'attachment', 'post_mime_type' => 'image', 'order' => $order, 'orderby' => $orderby) );
  
  		$attachments = array();
--- 711,716 ----
***************
*** 818,824 ****
  			$attachments[$val->ID] = $_attachments[$key];
  		}
  	} elseif ( !empty($exclude) ) {
- 		$exclude = preg_replace( '/[^0-9,]+/', '', $exclude );
  		$attachments = get_children( array('post_parent' => $id, 'exclude' => $exclude, 'post_status' => 'inherit', 'post_type' => 'attachment', 'post_mime_type' => 'image', 'order' => $order, 'orderby' => $orderby) );
  	} else {
  		$attachments = get_children( array('post_parent' => $id, 'post_status' => 'inherit', 'post_type' => 'attachment', 'post_mime_type' => 'image', 'order' => $order, 'orderby' => $orderby) );
--- 718,723 ----
***************
*** 928,936 ****
   * @param bool $prev Optional. Default is true to display previous link, false for next.
   */
  function adjacent_image_link($prev = true, $size = 'thumbnail', $text = false) {
! 	global $post;
! 	$post = get_post($post);
! 	$attachments = array_values(get_children( array('post_parent' => $post->post_parent, 'post_status' => 'inherit', 'post_type' => 'attachment', 'post_mime_type' => 'image', 'order' => 'ASC', 'orderby' => 'menu_order ID') ));
  
  	foreach ( $attachments as $k => $attachment )
  		if ( $attachment->ID == $post->ID )
--- 827,834 ----
   * @param bool $prev Optional. Default is true to display previous link, false for next.
   */
  function adjacent_image_link($prev = true, $size = 'thumbnail', $text = false) {
! 	$post = get_post();
! 	$attachments = array_values( get_children( array( 'post_parent' => $post->post_parent, 'post_status' => 'inherit', 'post_type' => 'attachment', 'post_mime_type' => 'image', 'order' => 'ASC', 'orderby' => 'menu_order ID' ) ) );
  
  	foreach ( $attachments as $k => $attachment )
  		if ( $attachment->ID == $post->ID )
***************
*** 938,945 ****
  
  	$k = $prev ? $k - 1 : $k + 1;
  
! 	if ( isset($attachments[$k]) )
! 		echo wp_get_attachment_link($attachments[$k]->ID, $size, true, false, $text);
  }
  
  /**
--- 836,849 ----
  
  	$k = $prev ? $k - 1 : $k + 1;
  
! 	$output = $attachment_id = null;
! 	if ( isset( $attachments[ $k ] ) ) {
! 		$attachment_id = $attachments[ $k ]->ID;
! 		$output = wp_get_attachment_link( $attachment_id, $size, true, false, $text );
! 	}
! 
! 	$adjacent = $prev ? 'previous' : 'next';
! 	echo apply_filters( "{$adjacent}_image_link", $output, $attachment_id, $size, $text );
  }
  
  /**
***************
*** 982,1019 ****
  }
  
  /**
!  * Check if the installed version of GD supports particular image type
   *
!  * @since 2.9.0
   *
!  * @param string $mime_type
!  * @return bool
   */
! function gd_edit_image_support($mime_type) {
! 	if ( function_exists('imagetypes') ) {
! 		switch( $mime_type ) {
! 			case 'image/jpeg':
! 				return (imagetypes() & IMG_JPG) != 0;
! 			case 'image/png':
! 				return (imagetypes() & IMG_PNG) != 0;
! 			case 'image/gif':
! 				return (imagetypes() & IMG_GIF) != 0;
! 		}
! 	} else {
! 		switch( $mime_type ) {
! 			case 'image/jpeg':
! 				return function_exists('imagecreatefromjpeg');
! 			case 'image/png':
! 				return function_exists('imagecreatefrompng');
! 			case 'image/gif':
! 				return function_exists('imagecreatefromgif');
  		}
  	}
! 	return false;
  }
  
  /**
   * Create new GD image resource with transparency support
   *
   * @since 2.9.0
   *
--- 886,922 ----
  }
  
  /**
!  * Return all of the taxonomy names that are registered for attachments.
   *
!  * Handles mime-type-specific taxonomies such as attachment:image and attachment:video.
!  *
!  * @since 3.5.0
!  * @see get_attachment_taxonomies()
!  * @uses get_taxonomies()
   *
!  * @param string $output The type of output to return, either taxonomy 'names' or 'objects'. 'names' is the default.
!  * @return array The names of all taxonomy of $object_type.
   */
! function get_taxonomies_for_attachments( $output = 'names' ) {
! 	$taxonomies = array();
! 	foreach ( get_taxonomies( array(), 'objects' ) as $taxonomy ) {
! 		foreach ( $taxonomy->object_type as $object_type ) {
! 			if ( 'attachment' == $object_type || 0 === strpos( $object_type, 'attachment:' ) ) {
! 				if ( 'names' == $output )
! 					$taxonomies[] = $taxonomy->name;
! 				else
! 					$taxonomies[ $taxonomy->name ] = $taxonomy;
! 				break;
! 			}
  		}
  	}
! 
! 	return $taxonomies;
  }
  
  /**
   * Create new GD image resource with transparency support
+  * @TODO: Deprecate if possible.
   *
   * @since 2.9.0
   *
***************
*** 1031,1315 ****
  }
  
  /**
-  * API for easily embedding rich media such as videos and images into content.
-  *
-  * @package WordPress
-  * @subpackage Embed
-  * @since 2.9.0
-  */
- class WP_Embed {
- 	var $handlers = array();
- 	var $post_ID;
- 	var $usecache = true;
- 	var $linkifunknown = true;
- 
- 	/**
- 	 * Constructor
- 	 */
- 	function __construct() {
- 		// Hack to get the [embed] shortcode to run before wpautop()
- 		add_filter( 'the_content', array(&$this, 'run_shortcode'), 8 );
- 
- 		// Shortcode placeholder for strip_shortcodes()
- 		add_shortcode( 'embed', '__return_false' );
- 
- 		// Attempts to embed all URLs in a post
- 		if ( get_option('embed_autourls') )
- 			add_filter( 'the_content', array(&$this, 'autoembed'), 8 );
- 
- 		// After a post is saved, invalidate the oEmbed cache
- 		add_action( 'save_post', array(&$this, 'delete_oembed_caches') );
- 
- 		// After a post is saved, cache oEmbed items via AJAX
- 		add_action( 'edit_form_advanced', array(&$this, 'maybe_run_ajax_cache') );
- 	}
- 
- 	/**
- 	 * Process the [embed] shortcode.
- 	 *
- 	 * Since the [embed] shortcode needs to be run earlier than other shortcodes,
- 	 * this function removes all existing shortcodes, registers the [embed] shortcode,
- 	 * calls {@link do_shortcode()}, and then re-registers the old shortcodes.
- 	 *
- 	 * @uses $shortcode_tags
- 	 * @uses remove_all_shortcodes()
- 	 * @uses add_shortcode()
- 	 * @uses do_shortcode()
- 	 *
- 	 * @param string $content Content to parse
- 	 * @return string Content with shortcode parsed
- 	 */
- 	function run_shortcode( $content ) {
- 		global $shortcode_tags;
- 
- 		// Back up current registered shortcodes and clear them all out
- 		$orig_shortcode_tags = $shortcode_tags;
- 		remove_all_shortcodes();
- 
- 		add_shortcode( 'embed', array(&$this, 'shortcode') );
- 
- 		// Do the shortcode (only the [embed] one is registered)
- 		$content = do_shortcode( $content );
- 
- 		// Put the original shortcodes back
- 		$shortcode_tags = $orig_shortcode_tags;
- 
- 		return $content;
- 	}
- 
- 	/**
- 	 * If a post/page was saved, then output JavaScript to make
- 	 * an AJAX request that will call WP_Embed::cache_oembed().
- 	 */
- 	function maybe_run_ajax_cache() {
- 		global $post_ID;
- 
- 		if ( empty($post_ID) || empty($_GET['message']) || 1 != $_GET['message'] )
- 			return;
- 
- ?>
- <script type="text/javascript">
- /* <![CDATA[ */
- 	jQuery(document).ready(function($){
- 		$.get("<?php echo admin_url( 'admin-ajax.php?action=oembed-cache&post=' . $post_ID, 'relative' ); ?>");
- 	});
- /* ]]> */
- </script>
- <?php
- 	}
- 
- 	/**
- 	 * Register an embed handler. Do not use this function directly, use {@link wp_embed_register_handler()} instead.
- 	 * This function should probably also only be used for sites that do not support oEmbed.
- 	 *
- 	 * @param string $id An internal ID/name for the handler. Needs to be unique.
- 	 * @param string $regex The regex that will be used to see if this handler should be used for a URL.
- 	 * @param callback $callback The callback function that will be called if the regex is matched.
- 	 * @param int $priority Optional. Used to specify the order in which the registered handlers will be tested (default: 10). Lower numbers correspond with earlier testing, and handlers with the same priority are tested in the order in which they were added to the action.
- 	 */
- 	function register_handler( $id, $regex, $callback, $priority = 10 ) {
- 		$this->handlers[$priority][$id] = array(
- 			'regex'    => $regex,
- 			'callback' => $callback,
- 		);
- 	}
- 
- 	/**
- 	 * Unregister a previously registered embed handler. Do not use this function directly, use {@link wp_embed_unregister_handler()} instead.
- 	 *
- 	 * @param string $id The handler ID that should be removed.
- 	 * @param int $priority Optional. The priority of the handler to be removed (default: 10).
- 	 */
- 	function unregister_handler( $id, $priority = 10 ) {
- 		if ( isset($this->handlers[$priority][$id]) )
- 			unset($this->handlers[$priority][$id]);
- 	}
- 
- 	/**
- 	 * The {@link do_shortcode()} callback function.
- 	 *
- 	 * Attempts to convert a URL into embed HTML. Starts by checking the URL against the regex of the registered embed handlers.
- 	 * If none of the regex matches and it's enabled, then the URL will be given to the {@link WP_oEmbed} class.
- 	 *
- 	 * @uses wp_oembed_get()
- 	 * @uses wp_parse_args()
- 	 * @uses wp_embed_defaults()
- 	 * @uses WP_Embed::maybe_make_link()
- 	 * @uses get_option()
- 	 * @uses current_user_can()
- 	 * @uses wp_cache_get()
- 	 * @uses wp_cache_set()
- 	 * @uses get_post_meta()
- 	 * @uses update_post_meta()
- 	 *
- 	 * @param array $attr Shortcode attributes.
- 	 * @param string $url The URL attempting to be embedded.
- 	 * @return string The embed HTML on success, otherwise the original URL.
- 	 */
- 	function shortcode( $attr, $url = '' ) {
- 		global $post;
- 
- 		if ( empty($url) )
- 			return '';
- 
- 		$rawattr = $attr;
- 		$attr = wp_parse_args( $attr, wp_embed_defaults() );
- 
- 		// kses converts & into &amp; and we need to undo this
- 		// See http://core.trac.wordpress.org/ticket/11311
- 		$url = str_replace( '&amp;', '&', $url );
- 
- 		// Look for known internal handlers
- 		ksort( $this->handlers );
- 		foreach ( $this->handlers as $priority => $handlers ) {
- 			foreach ( $handlers as $id => $handler ) {
- 				if ( preg_match( $handler['regex'], $url, $matches ) && is_callable( $handler['callback'] ) ) {
- 					if ( false !== $return = call_user_func( $handler['callback'], $matches, $attr, $url, $rawattr ) )
- 						return apply_filters( 'embed_handler_html', $return, $url, $attr );
- 				}
- 			}
- 		}
- 
- 		$post_ID = ( !empty($post->ID) ) ? $post->ID : null;
- 		if ( !empty($this->post_ID) ) // Potentially set by WP_Embed::cache_oembed()
- 			$post_ID = $this->post_ID;
- 
- 		// Unknown URL format. Let oEmbed have a go.
- 		if ( $post_ID ) {
- 
- 			// Check for a cached result (stored in the post meta)
- 			$cachekey = '_oembed_' . md5( $url . serialize( $attr ) );
- 			if ( $this->usecache ) {
- 				$cache = get_post_meta( $post_ID, $cachekey, true );
- 
- 				// Failures are cached
- 				if ( '{{unknown}}' === $cache )
- 					return $this->maybe_make_link( $url );
- 
- 				if ( !empty($cache) )
- 					return apply_filters( 'embed_oembed_html', $cache, $url, $attr, $post_ID );
- 			}
- 
- 			// Use oEmbed to get the HTML
- 			$attr['discover'] = ( apply_filters('embed_oembed_discover', false) && author_can( $post_ID, 'unfiltered_html' ) );
- 			$html = wp_oembed_get( $url, $attr );
- 
- 			// Cache the result
- 			$cache = ( $html ) ? $html : '{{unknown}}';
- 			update_post_meta( $post_ID, $cachekey, $cache );
- 
- 			// If there was a result, return it
- 			if ( $html )
- 				return apply_filters( 'embed_oembed_html', $html, $url, $attr, $post_ID );
- 		}
- 
- 		// Still unknown
- 		return $this->maybe_make_link( $url );
- 	}
- 
- 	/**
- 	 * Delete all oEmbed caches.
- 	 *
- 	 * @param int $post_ID Post ID to delete the caches for.
- 	 */
- 	function delete_oembed_caches( $post_ID ) {
- 		$post_metas = get_post_custom_keys( $post_ID );
- 		if ( empty($post_metas) )
- 			return;
- 
- 		foreach( $post_metas as $post_meta_key ) {
- 			if ( '_oembed_' == substr( $post_meta_key, 0, 8 ) )
- 				delete_post_meta( $post_ID, $post_meta_key );
- 		}
- 	}
- 
- 	/**
- 	 * Triggers a caching of all oEmbed results.
- 	 *
- 	 * @param int $post_ID Post ID to do the caching for.
- 	 */
- 	function cache_oembed( $post_ID ) {
- 		$post = get_post( $post_ID );
- 
- 		if ( empty($post->ID) || !in_array( $post->post_type, apply_filters( 'embed_cache_oembed_types', array( 'post', 'page' ) ) ) )
- 			return;
- 
- 		// Trigger a caching
- 		if ( !empty($post->post_content) ) {
- 			$this->post_ID = $post->ID;
- 			$this->usecache = false;
- 
- 			$content = $this->run_shortcode( $post->post_content );
- 			if ( get_option('embed_autourls') )
- 				$this->autoembed( $content );
- 
- 			$this->usecache = true;
- 		}
- 	}
- 
- 	/**
- 	 * Passes any unlinked URLs that are on their own line to {@link WP_Embed::shortcode()} for potential embedding.
- 	 *
- 	 * @uses WP_Embed::autoembed_callback()
- 	 *
- 	 * @param string $content The content to be searched.
- 	 * @return string Potentially modified $content.
- 	 */
- 	function autoembed( $content ) {
- 		return preg_replace_callback( '|^\s*(https?://[^\s"]+)\s*$|im', array(&$this, 'autoembed_callback'), $content );
- 	}
- 
- 	/**
- 	 * Callback function for {@link WP_Embed::autoembed()}.
- 	 *
- 	 * @uses WP_Embed::shortcode()
- 	 *
- 	 * @param array $match A regex match array.
- 	 * @return string The embed HTML on success, otherwise the original URL.
- 	 */
- 	function autoembed_callback( $match ) {
- 		$oldval = $this->linkifunknown;
- 		$this->linkifunknown = false;
- 		$return = $this->shortcode( array(), $match[1] );
- 		$this->linkifunknown = $oldval;
- 
- 		return "\n$return\n";
- 	}
- 
- 	/**
- 	 * Conditionally makes a hyperlink based on an internal class variable.
- 	 *
- 	 * @param string $url URL to potentially be linked.
- 	 * @return string Linked URL or the original URL.
- 	 */
- 	function maybe_make_link( $url ) {
- 		$output = ( $this->linkifunknown ) ? '<a href="' . esc_attr($url) . '">' . esc_html($url) . '</a>' : $url;
- 		return apply_filters( 'embed_maybe_make_link', $output, $url );
- 	}
- }
- $GLOBALS['wp_embed'] = new WP_Embed();
- 
- /**
   * Register an embed handler. This function should probably only be used for sites that do not support oEmbed.
   *
   * @since 2.9.0
--- 934,939 ----
***************
*** 1334,1364 ****
  /**
   * Create default array of embed parameters.
   *
   * @since 2.9.0
   *
   * @return array Default embed parameters.
   */
  function wp_embed_defaults() {
! 	if ( !empty($GLOBALS['content_width']) )
! 		$theme_width = (int) $GLOBALS['content_width'];
! 
! 	$width = get_option('embed_size_w');
! 
! 	if ( empty($width) && !empty($theme_width) )
! 		$width = $theme_width;
  
! 	if ( empty($width) )
  		$width = 500;
  
! 	$height = get_option('embed_size_h');
  
! 	if ( empty($height) )
! 		$height = 700;
! 
! 	return apply_filters( 'embed_defaults', array(
! 		'width'  => $width,
! 		'height' => $height,
! 	) );
  }
  
  /**
--- 958,984 ----
  /**
   * Create default array of embed parameters.
   *
+  * The width defaults to the content width as specified by the theme. If the
+  * theme does not specify a content width, then 500px is used.
+  *
+  * The default height is 1.5 times the width, or 1000px, whichever is smaller.
+  *
+  * The 'embed_defaults' filter can be used to adjust either of these values.
+  *
   * @since 2.9.0
   *
   * @return array Default embed parameters.
   */
  function wp_embed_defaults() {
! 	if ( ! empty( $GLOBALS['content_width'] ) )
! 		$width = (int) $GLOBALS['content_width'];
  
! 	if ( empty( $width ) )
  		$width = 500;
  
! 	$height = min( ceil( $width * 1.5 ), 1000 );
  
! 	return apply_filters( 'embed_defaults', compact( 'width', 'height' ) );
  }
  
  /**
***************
*** 1420,1425 ****
--- 1040,1068 ----
  }
  
  /**
+  * Removes an oEmbed provider.
+  *
+  * @since 3.5
+  * @see WP_oEmbed
+  *
+  * @uses _wp_oembed_get_object()
+  *
+  * @param string $format The URL format for the oEmbed provider to remove.
+  */
+ function wp_oembed_remove_provider( $format ) {
+ 	require_once( ABSPATH . WPINC . '/class-oembed.php' );
+ 
+ 	$oembed = _wp_oembed_get_object();
+ 
+ 	if ( isset( $oembed->providers[ $format ] ) ) {
+ 		unset( $oembed->providers[ $format ] );
+ 		return true;
+ 	}
+ 
+ 	return false;
+ }
+ 
+ /**
   * Determines if default embed handlers should be loaded.
   *
   * Checks to make sure that the embeds library hasn't already been loaded. If
